function [durations, meanSDs, params, signature, paramstore, probpairs] = calcSDs(activations,conditions,subjects,nstates)

%calculate params for each subject, use these to calc mean sds

ndims = size(activations,2)-1; %number of factors
mask = ones(1,nstates);
nconds = max(conditions);
nsubjs=max(subjects);
params = zeros(nstates,2,nconds,nsubjs);

probtemp = cell(1,nsubjs);
probpairs = zeros(size(activations,1),nstates); %store all probpairs from sub by sub estimation

fprintf('Calculating basis.\n');
ratio = 2 / (1/12.5);

%old
%paramsx = repmat([1 (1.5*ratio)/nstates], nstates,1);

%new
x = find(activations(:,1) == 1); %start of trials
lengths = activations(cat(1,x(2:end)-1,size(activations,1)),1); %trial lengths
paramsx = repmat(sqrt(mean(lengths)*2/nstates),[nstates,2,1]);

[~, signature, paramstore ] = hsmmEstimateConds3(activations,conditions,zeros(ndims,nstates),paramsx,.01);

parfor i = 1:nsubjs
    fprintf('Subject %d of %d\n',i, nsubjs);
   
    [params(:,:,:,i), probtemp{i}, ~] = generalEstimateTimes(activations(subjects==i,:),conditions(subjects==i), ...
        signature,paramsx,.01,mask,nconds);
end

durations = squeeze(prod(paramstore,2))' / ratio * 1000;
meanSDs = zeros(nconds, nstates, nsubjs);
for i = 1:nsubjs
    meanSDs(:,:,i) = sqrt(squeeze(prod(params(:,[1,2,2],:,i),2)))' / ratio * 1000;
    probpairs(subjects==i,:) = probtemp{i};
end

meanSDs = mean(meanSDs, 3);





