function [tempodds,probpairs,durations,temp,priorprobpairs,priordurations] = genTrial4(actlogs,lags)

samplesInTrial = size(actlogs,1); %trial length
nstates = size(actlogs,2); %nstates

temp = zeros(samplesInTrial+1,1); %holds logodds of splits for fragments of different lengths
temp3 = temp;

priorprobpairs = zeros(samplesInTrial, nstates-1, samplesInTrial+1); %distribution of probs if lengths
probpairs = zeros(samplesInTrial, nstates);
durations = zeros(samplesInTrial+1, nstates);
priordurations = zeros(samplesInTrial+1, nstates-1, samplesInTrial+1); %distribution if last length
for i = 1:samplesInTrial
    priorprobpairs(1:i,1,i+1)=1;
    priordurations(i,1,i)=1;
end
priordurations(samplesInTrial+1,1,samplesInTrial+1)=1;
sumactodds = 0;
%initialize first dimension
temp(1)=lags(1,1);
for j = 2:samplesInTrial+1
    sumactodds=sumactodds+actlogs(j-1);
    temp(j)=sumactodds+lags(j,1);
end
for wi = 2:nstates-1
    priorprobpairs1=zeros(samplesInTrial,nstates-1,samplesInTrial+1);
    priordurations1=zeros(samplesInTrial+1,nstates-1,samplesInTrial+1);
    temp1=zeros(samplesInTrial+1,samplesInTrial+1); %different breaks for different lengths
    temp1(1,1)=temp(1)+lags(1,wi); %another null
    temp3(1)=temp1(1,1);  %by the end temp will become temp
    for mi = 1:samplesInTrial  %iterate through lengths
        temp1(mi+1,mi+1)=temp(mi+1)+lags(1,wi); %null added to full
        sumactodds=0;
        for j = mi:-1:1
            sumactodds = sumactodds+actlogs(j,wi); %***
            temp1(j,mi+1)=temp(j)+sumactodds+lags(mi+2-j,wi);
        end
        maxodds = max(temp1(1:mi+1,mi+1));
        temp2 = exp(temp1(1:mi+1,mi+1) - maxodds); %temp2 for prior duration
        sumprobs = sum(temp2);
        temp3(mi+1)=maxodds+log(sumprobs);
        temp2 = temp2/sumprobs;
        priorprobpairs1(1,wi,mi+1)=temp2(1);
        priorprobpairs1(:,1:wi-1,mi+1)=temp2(mi+1)*priorprobpairs(:,1:wi-1,mi+1);
        for j = 2:mi
            priorprobpairs1(j,wi,mi+1)=priorprobpairs1(j-1,wi,mi+1)+temp2(j);
            priorprobpairs1(:,1:wi-1,mi+1)=priorprobpairs(:,1:wi-1,j)*temp2(j)+priorprobpairs1(:,1:wi-1,mi+1);
        end
        for j = 1:mi+1
            priordurations1(j,wi,mi+1)=temp2(mi-j+2);
            priordurations1(1:(mi-j+2),1:wi-1,mi+1)=priordurations1(1:(mi-j+2),1:wi-1,mi+1)+priordurations(1:(mi-j+2),1:wi-1,mi-j+2)*temp2(mi-j+2);
        end
    end
    priordurations1(1,:,1)=1;
    priordurations=priordurations1;
    priorprobpairs=priorprobpairs1;
    temp = temp3;
end
%complete final dimension; temp(i) is logodds of the first w-1 taking i
%scans
temp(samplesInTrial+1)=temp(samplesInTrial+1)+lags(1,nstates);
sumactodds = 0;
for j = samplesInTrial:-1:1
    sumactodds = sumactodds+actlogs(j,nstates);
    temp(j)=temp(j)+sumactodds+lags(samplesInTrial+2-j,nstates);
end
maxodds = max(temp);
temp = exp(temp - maxodds);
sumprobs = sum(temp);
tempodds = maxodds+log(sumprobs);
temp = temp/sumprobs;
probpairs(1,nstates)=temp(1);
probpairs(:,1:nstates-1)=temp(samplesInTrial+1)*priorprobpairs(:,1:nstates-1,samplesInTrial+1);
for j = 2:samplesInTrial
    probpairs(j,nstates)=probpairs(j-1,nstates)+temp(j);
    probpairs(:,1:nstates-1)=priorprobpairs(:,1:nstates-1,j)*temp(j)+probpairs(:,1:nstates-1);
end
for j = 1:samplesInTrial+1
    durations(j,nstates)=temp(samplesInTrial-j+2);
    durations(:,1:nstates-1)=durations(:,1:nstates-1)+priordurations(:,1:nstates-1,samplesInTrial-j+2)*temp(samplesInTrial-j+2);
end