function [likebest,  paramsf, meansf] = generalLinearCondsTimes2(activations,subjects, conds, N,trials,start)
%do likelikhood estimation, allowing for timing parameters for each
%subject. Make it a true test, by splitting subject data in half.


if nargin < 6
    start = 1;
end
    
%disp(start);

global maxlength;
maxlength = max(21,max(activations(:,1)));

nsubjs =max(subjects);
likebest = zeros(nsubjs,N-start+1);

%vector = 1
if start == 1
    fprintf('\nCalculating loglikelihoods for 1 state...\n\n');
    
    A=[0 1;1 0];
    
    [likebest(:,1),paramsf{1},meansf{1}] = hsmmStateFreezeCondsTimes2(activations,subjects,A,conds,trials);
    
    fprintf('\n...done.\n\n');
    start = 2;
end

for i = start:N 

    fprintf('Calculating loglikelihoods for %d states...\n\n', i);

    A = cat(2, cat(1,zeros(i,1),1), cat(1, diag(ones(i,1)),zeros(1,i))); %just a linear structure
    
    [likebest(:,i), paramsf{i}, meansf{i}] = hsmmStateFreezeCondsTimes2(activations,subjects,A,conds,trials);
        
    fprintf('\n...done.\n\n');
    
    %if likebest(1,i-1) ~= 0
    %    fprintf('%d subjects improved.\n\n', sum(likebest(:,i)>likebest(:,i-1)));
    %end
    
end



