function [like, params, means] = hsmmStateFreezeCondsTimes2(activations,subjects,A,conds,trials)
%do likelikhood estimation, allowing for timing parameters for each
%subject. Make it a true test, by splitting subject data in half.

nstates = size(A,1)-1; %calc number of states

ndims = size(activations,2)-1; %number of factors

nsubjs = max(subjects); %number of subs
nconds = max(conds);
mask = ones(1,nstates);

%activations(:,2:end) = min(max(activations(:,2:end),-5),5); %cap
%activations at 5 - i already removed outliers. Not sure.

x = find(activations(:,1) == 1); %start of trials

lengths = activations(cat(1,x(2:end)-1,size(activations,1)),1); %trial lengths
nconds = size(unique(conds),1); 

evenodd = 2 - mod(trials,2); %2 for even trials, 1 for odd

paramsx = repmat(sqrt(mean(lengths)*2/nstates),[nstates,2,nconds]); %initialize params
meansx = zeros(ndims,nstates); %initialize means

means = zeros(ndims,nstates,nsubjs); 
params = repmat(paramsx,[1,1,1,nsubjs]);

%[lkh, meansx, paramsx]
%=hsmmEstimateFreeze(PAI,A,meansx,paramsx,activations(:,1:21),.01,1);

like = zeros(nsubjs,1);
parfor i = 1:nsubjs
    if sum(subjects==i) == 0
    else
        fprintf('\tEstimating LOOCV-value for subject %d...\n', i);
        
        %calc best fit for other subs
        
        [lkh,means(:,:,i), params(:,:,:,i)] = hsmmEstimateConds3(activations(subjects~=i,:),conds(subjects~=i),meansx,paramsx,.01);
        
        %disp(lkh)
        
        %calc the likelihood for current sub
        %like(i) = hsmmEstimateConds3(activations(subjects==i,:),conds(subjects==i),means(:,:,i),params(:,:,:,i),0);
        
        %do split half, estimate times on first half, test on second, and
        %vice versa
        
        likesplit = zeros(2,1);
        for half = 1:2
            
           %estimate time params based on first half
           paramsOtherHalf = generalEstimateTimes(activations(subjects==i & evenodd==half,:),conds(subjects==i & evenodd==half),means(:,:,i),params(:,:,:,i),.01,mask,nconds);

           likesplit(half) = hsmmEstimateConds3(activations(subjects==i & evenodd~=half,:),conds(subjects==i & evenodd~=half),means(:,:,i),paramsOtherHalf,0);

        end
        
        
        like(i) = mean(likesplit);
        %fprintf('\b done.\n')
    end
end
%mean(like)
