function [probpairs,logodds, durations] = probNs(lengths,params,actlogs,maxl)
%lengths is trial lengths
%params is current state parameters for this condition for n states
%actlogs = difference between estimated mean and data for all states

if nargin < 4
    global maxlength;
else
    maxlength = maxl;
end

%nsize = max(lengths);
ntrials = length(lengths);
nstates = size(params,1);
probpairs = zeros(ntrials, nstates); %probability that trial is in state

% the next 2 lines calculate 44 gammas and then logs ??
%fills in lags with estimated gammas based on params
lags = zeros(maxlength + 1, nstates);
for i = 1:nstates
    lags(:,i) = log(gammaN(params(i,1), params(i,2),maxlength));
end

%sourcelogs = zeros(nsize+1,nsize);  %log odds of different divisions
%on differnent number of trials
% 2 units of the computation goes into the above and below that calculate
% sourcelogs
% the next 2 lines calculate circa 300 sums
%for j = min(lengths):nsize
%    sourcelogs(1:j+1,j) = first(1:j+1)+wrev(second(1:j+1));
%end


logodds = 0;  %logodds of model
index = 0;
durations = zeros(maxlength + 1, nstates); %estimate of lengths of durations

%for each trial...
for i = 1:ntrials
    
    m = lengths(i); %length of trial
    
    %this functional embedding costs at least 3 units
    %[logodds1,probpairs1,durations1] = pairTrial(actlogs(index+1:index+m,:),sourcelogs,m);
    
    %given the difference between estimated means and data for this trial
    %and the lags given the current params, this calcs the ...
    [logodds1,probpairs1,durations1] = genTrial4(actlogs(index+1:index+m,:),lags);
    
    logodds = logodds+logodds1;
    probpairs(index+1:index+m,:)=probpairs1;
    durations(1:m+1,:)=durations(1:m+1,:)+durations1;
    index = index + m;
end